#include <bits/stdc++.h>
#define int long long
using namespace std;

int n, m, s;
vector<vector<int>> a;
vector<int> sm1, sm2;
vector<pair<int, int>> ans;

void rec(int i, int j, int sm) {
    if (i == n && j == m) {
        if (s == sm) {
            cout << "YES\n";

            cout << ans.size() << "\n";

            for (auto el : ans) {
                cout << el.first << ' ' << el.second << "\n";
            }

            exit(0);
        }

        return;
    }

    if (i == n) {
        rec(n, j + 1, sm);

        ans.emplace_back(2, j + 1);
        rec(n, j + 1, sm - sm2[j]);
        ans.pop_back();

        return;
    }

    rec(i + 1, j, sm);

    for (int x = 0; x < m; ++x) {
        sm2[x] -= a[i][x];
    }

    ans.emplace_back(1, i + 1);
    rec(i + 1, j, sm - sm1[i]);
    ans.pop_back();

    for (int x = 0; x < m; ++x) {
        sm2[x] += a[i][x];
    }
}

void solve() {
    ios_base::sync_with_stdio(false); cin.tie(nullptr); cout.tie(nullptr);

    int all_sm = 0;
    cin >> n >> m;

    a.resize(n, vector<int>(m));
    sm1.resize(n, 0), sm2.resize(m, 0);

    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cin >> a[i][j];
            sm1[i] += a[i][j];
            sm2[j] += a[i][j];

            all_sm += a[i][j];
        }
    }

    cin >> s;

    rec(0, 0, all_sm);

    cout << "NO";
}

signed main() {
    int tt = 1;

    while (tt--) {
        solve();
    }
}