#include <bits/stdc++.h>
#define int long long
using namespace std;

vector<bool> used;
vector<vector<int>> vert;
vector<int> d, p;

void dfs(int idx) {
    used[idx] = true;

    for (auto to : vert[idx]) {
        if (!used[to] || d[idx] + 1 < d[to]) {
            d[to] = d[idx] + 1;
            p[to] = idx;
            dfs(to);
        }
    }
}

void solve() {
    ios_base::sync_with_stdio(false); cin.tie(nullptr); cout.tie(nullptr);

    int n, k, t, a, b;
    cin >> n >> k >> t;


    vert.resize(n);

    for (int i = 1; i < n; ++i) {
        cin >> a >> b;

        vert[a - 1].push_back(b - 1);
        vert[b - 1].push_back(a - 1);
    }

    if (t == 0) {
        while (k--) {
            used.assign(n, false);
            d.assign(n, 0);
            p.assign(n, -1);
            dfs(0);

            int mx = 0;
            for (int i = 1; i < n; ++i) {
                if (d[mx] < d[i]) {
                    mx = i;
                }
            }

            int m = mx;
            while (d[m] != (d[mx] + 1) / 2) {
                m = p[m];
            }

            if (d[mx] == 2) {
                m = mx;
            }

            vert[0].push_back(m);
            vert[m].push_back(0);
        }

        used.assign(n, false);
        d.assign(n, 0);
        p.assign(n, -1);
        dfs(0);
        int mx = 0;
        for (int i = 1; i < n; ++i) {
            if (mx < d[i]) {
                mx = d[i];
            }
        }

        cout << mx;
    }
}

signed main() {
    int tt = 1;

    while (tt--) {
        solve();
    }
}