#include <bits/stdc++.h>
#define int long long
using namespace std;

int pw(int x, int y) {
    if (y == 1) {
        return x;
    }

    if (y % 2 == 1) {
        return pw(x, y / 2) * pw(x, y / 2) * x;
    }

    return pw(x, y / 2) * pw(x, y / 2);
}

signed main() {
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);

    int n, m, r = 1e12;
    cin >> n >> m;

    vector<int> a(n), b(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }

    for (int i = 0; i < n; ++i) {
        cin >> b[i];

        r = min(r, a[i] + b[i] + 32);
    }

    int l = 0, t, cur = 0;
    while (r - l > 1) {
        t = (l + r) / 2;

        cur = 0;
        for (int i = 0; i < n; ++i) {
            if (a[i] + b[i] <= t) {
                cur += pw(2, t - a[i] - b[i] + 1);
            } else if (a[i] <= t) {
                cur++;
            }
        }

        if (cur < m) {
            l = t;
        } else {
            r = t;
        }
    }

    t = r;

    cur = 0;
    for (int i = 0; i < n; ++i) {
        if (a[i] + b[i] <= t) {
            cur += pw(2, t - a[i] - b[i] + 1);
        } else if (a[i] <= t) {
            cur++;
        }
    }

    if (cur == m) {
        cout << r;
    } else {
        cout << -1;
    }

    return 0;
}