#include <bits/stdc++.h>
#define int long long

using namespace std;

int n, k, s, ans;

vector<int> used, d;
vector<vector<int>> vert;

void dfs(int idx) {
    for (auto to : vert[idx]) {
        if (d[to] > d[idx] + 1) {
            d[to] = d[idx] + 1;
            dfs(to);
        }
    }
}

void rec(int i) {
    if (i == n) {
        d.assign(n, LLONG_MAX);
        d[s] = 0;

        int cnt = 0;

        for (int j = 0; j < n; ++j) {
            if (used[j] == 1) {
                vert[s].push_back(j);
                ++cnt;
            }
        }

        dfs(s);

        int cur = 0;
        for (int j = 0; j < n; ++j) {
            if (used[j] == 1) {
                vert[s].pop_back();
            }

            cur = max(cur, d[j]);
        }

        if (cnt <= k) {
            return;
        }

        ans = min(ans, cur);

        return;
    }

    if (i == s) {
        used.push_back(0);
        rec(i + 1);
        used.pop_back();

        return;
    }

    used.push_back(0);
    rec(i + 1);
    used.pop_back();

    used.push_back(1);
    rec(i + 1);
    used.pop_back();
}

void solve() {
    ios_base::sync_with_stdio(false); cin.tie(nullptr); cout.tie(nullptr);

    int t, a, b;
    cin >> n >> k >> t;

    if (n == 1) {
        cout << 0;
        return;
    }

    vert.resize(n);

    bool flag = true;
    for (int i = 1; i < n; ++i) {
        cin >> a >> b;

        if (min(a, b) + 1 != max(a, b)) {
            flag = false;
        }

        vert[a - 1].push_back(b - 1);
        vert[b - 1].push_back(a - 1);
    }

    if (t == 0 && flag) {
        ++k;
        cout << (n + k - 2) / k;

        return;
    }

    if (t == 0) {
        ans = LLONG_MAX;
        s = 0;
        rec(0);

        cout << ans;
    } else {
        for (int i = 0; i < n; ++i) {
            s = i;

            ans = LLONG_MAX;
            rec(0);

            cout << ans << ' ';
        }
    }
}

signed main() {
    int tt = 1;

    while (tt--) {
        solve();
    }
}