#include <bits/stdc++.h>
#define int long long
using namespace std;

vector<vector<int>> vert;
vector<int> d, p;

void dfs(int idx) {
    for (auto to : vert[idx]) {
        if (p[idx] != to) {
            d[to] = d[idx] + 1;
            p[to] = idx;
            dfs(to);
        }
    }
}

void solve() {
    ios_base::sync_with_stdio(false); cin.tie(nullptr); cout.tie(nullptr);

    int n, k, t, a, b, mx = LLONG_MAX;
    cin >> n >> k >> t;

    vert.resize(n);
    for (int i = 0; i < n - 1; ++i) {
        cin >> a >> b;

        vert[a - 1].push_back(b - 1);
        vert[b - 1].push_back(a - 1);
    }

    if (k > 1) {
        ++k;
        cout << (n + k - 2) / k;

        return;
    }

    for (int i = 1; i < n; ++i) {
        vert[0].push_back(1);
        vert[1].push_back(0);

        d.resize(n, 0);
        p.resize(n, -1);

        dfs(0);

        int cur = 0;
        for (int j = 1; j < n; ++j) {
            cur = max(cur, d[j]);
        }

        mx = min(mx, cur);
    }

    cout << mx;
}

signed main() {
    int tt = 1;

    while (tt--) {
        solve();
    }
}