#include <bits/stdc++.h>
#define int long long
using namespace std;

vector<vector<int>> vert;
vector<int> d, p;

void dfs(int idx) {
    for (auto to : vert[idx]) {
        if (d[to] > d[idx] + 1) {
            d[to] = d[idx] + 1;
            p[to] = idx;
            dfs(to);
        }
    }
}

void solve() {
    ios_base::sync_with_stdio(false); cin.tie(nullptr); cout.tie(nullptr);

    int n, k, t, a, b, mx = LLONG_MAX;
    cin >> n >> k >> t;

    vert.resize(n);
    for (int i = 0; i < n - 1; ++i) {
        cin >> a >> b;

        vert[a - 1].push_back(b - 1);
        vert[b - 1].push_back(a - 1);
    }

    if (k > 1) {
        ++k;
        cout << (n + k - 2) / k;

        return;
    }

    d.resize(n, LLONG_MAX);
    p.resize(n, -1);
    d[0] = 0;

    dfs(0);

    set<int> s;
    s.insert(0);

    for (int i = 1; i < n; ++i) {
        if (d[i] > d[*s.begin()]) {
            s.clear();
            s.insert(i);
        }
    }

    while (s.size() > 1) {
        set<int> ss;

        for (auto el : s) {
            ss.insert(p[el]);
        }

        s = ss;
    }

    vector<int> all = {*s.begin()};
    while (p[*s.begin()] != 1) {
        all.push_back(p[*s.begin()]);
        int x = p[*s.begin()];
        s.clear();
        s.insert(x);
    }

    for (auto i : all) {
        vert[0].push_back(i);
        vert[i].push_back(0);

        d.assign(n, LLONG_MAX);
        d[0] = 0;

        dfs(0);

        int cur = 0;
        for (int j = 1; j < n; ++j) {
            cur = max(cur, d[j]);
        }

        mx = min(mx, cur);

        vert[0].pop_back();
        vert[i].pop_back();
    }

    cout << mx;
}

signed main() {
    int tt = 1;

    while (tt--) {
        solve();
    }
}