#include <bits/stdc++.h>
#define int long long
using namespace std;

const int MOD = 1e9 + 7;

int n, m, ans = 0;
map<int, int> cnt;

int rec(int x) {
    if (x == 3) {
        int cur = 0;

        for (int i = 0; i <= min(cnt[1], min(cnt[2], cnt[3])); ++i) {
            if (cnt[1] % 3 == i % 3 && cnt[2] % 3 == i % 3 && cnt[3] % 3 == i % 3) {
                ++cur;
            }
        }

        return cur;
    }

    int cur = 0;
    for (int i = 0; i <= cnt[x]; i += 3) {
        cnt[x - 1] -= cnt[x] - i;
        cnt[x - 2] -= cnt[x] - i;

        cur += rec(x - 1);

        cnt[x - 1] += cnt[x] - i;
        cnt[x - 2] += cnt[x] - i;
    }

    return cur;
}

signed main() {
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);

    cin >> n >> m;

    bool flag = true;

    int x;
    for (int i = 0; i < n; ++i) {
        cin >> x;
        cnt[x]++;

        if (x % 4 == 0) {
            flag = false;
        }
    }

    if (flag) {
        ans = 1;

        int cur;
        for (int q = 0; q < m; q += 4) {
            cur = 0;

            for (int i = 0; i <= min(cnt[q + 1], min(cnt[q + 2], cnt[q + 3])); ++i) {
                if (cnt[q + 1] % 3 == i % 3 && cnt[q + 2] % 3 == i % 3 && cnt[q + 3] % 3 == i % 3) {
                    ++cur;
                }
            }

            ans *= cur;
            ans %= MOD;
        }

        cout << ans;
        return 0;
    }

    cout << rec(m);

    return 0;
}