#include <bits/stdc++.h>
#define int long long
using namespace std;

const int MOD = 1e9 + 7;

int n, m, ans = 0;
map<int, int> cnt;

int rec(int x) {
    if (x == 3) {
        int cur = 0;

        for (int i = 0; i <= min(cnt[1], min(cnt[2], cnt[3])); ++i) {
            if (cnt[1] % 3 == i % 3 && cnt[2] % 3 == i % 3 && cnt[3] % 3 == i % 3) {
                ++cur;
            }
        }

        return cur;
    }

    int cur = 0;
    for (int i = 0; i <= cnt[x]; i += 3) {
        cnt[x - 1] -= cnt[x] - i;
        cnt[x - 2] -= cnt[x] - i;

        cur += rec(x - 1);

        cnt[x - 1] += cnt[x] - i;
        cnt[x - 2] += cnt[x] - i;
    }

    return cur;
}

signed main() {
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);

    int mx = 0;
    cin >> n >> m;

    bool flag = true;

    int x;
    for (int i = 0; i < n; ++i) {
        cin >> x;
        cnt[x]++;

        mx = max(mx, cnt[x]);

        if (x % 4 == 0) {
            flag = false;
        }
    }

    if (flag) {
        ans = 1;

        int cur;
        for (int q = 0; q < m; q += 4) {
            cur = 0;

            for (int i = 0; i <= min(cnt[q + 1], min(cnt[q + 2], cnt[q + 3])); ++i) {
                if (cnt[q + 1] % 3 == i % 3 && cnt[q + 2] % 3 == i % 3 && cnt[q + 3] % 3 == i % 3) {
                    ++cur;
                }
            }

            ans *= cur;
            ans %= MOD;
        }

        cout << ans;
        return 0;
    }

    if (mx < 3 || m < 5) {
        cout << rec(m);
        return 0;
    }

    vector<int> a(m + 1);
    for (int i = 1; i <= m; ++i) {
        a[i] = cnt[i];
    }

    for (int i = m; i > 2; --i) {
        a[i - 2] -= a[i] % 3;
        a[i - 1] -= a[i] % 3;

        if (min(a[i - 2], a[i - 1]) < 0) {
            cout << 0;
            return 0;
        }

        a[i] /= 3;
    }

    if (a[1] % 3 > 0 || a[2] % 3 > 0) {
        cout << 0;
        return 0;
    }

    a[1] /= 3;
    a[2] /= 3;

    vector<vector<vector<int>>> dp(m + 1, vector<vector<int>>(n / 3 + 1, vector<int>(n / 3 + 1, 0)));
    for (int i = 0; i <= a[1]; ++i) {
        for (int j = 0; j <= a[2]; ++j) {
            dp[2][i][j] = 1;
        }
    }

    for (int i = 3; i <= m; ++i) {
        for (int j = 0; j <= a[i - 1]; ++j) {
            for (int k = 0; k <= a[i]; ++k) {
                for (x = 0; x <= min(a[i - 2], min(j, k)); ++x) {
                    dp[i][j][k] += dp[i - 1][a[i - 2] - x][j - x];
                }
            }
        }
    }

    cout << dp[m][a[m - 1]][a[m]];

    return 0;
}